﻿using GTA;
using System;
using System.Windows.Forms;
using System.Collections.Generic;
using GTA.Native;
using GTA.Math;

public class Skyrim_Shout : Script
{
    int shout_strength = 100;

    public Skyrim_Shout()
    {
        Tick += OnTick;
        KeyDown += OnKeyDown;
        KeyUp += OnKeyUp;

        Interval = 10;
    }
    void OnTick(object sender, EventArgs e)
    {
    }

    void OnKeyDown(object sender, KeyEventArgs e)
    {
        if (e.KeyCode == Keys.Add)
        {
            shout_strength = shout_strength + 1;
            GTA.UI.ShowSubtitle("Shout Strength is now " + shout_strength.ToString());
        }
        if (e.KeyCode == Keys.Subtract)
        {
            shout_strength = shout_strength - 1;
            GTA.UI.ShowSubtitle("Shout Strength is now " + shout_strength.ToString());
        }
    }

    void DeletePEDArray(Ped[] pedObj)
    {
        for (int i = 0; i < pedObj.Length; i++)
        {
            pedObj[i] = null;
        }
        pedObj = null;
    }

    void DeleteVEHArray(Vehicle[] vObj)
    {
        for (int i = 0; i < vObj.Length; i++)
        {
            vObj[i] = null;
        }
        vObj = null;
    }

    void OnKeyUp(object sender, KeyEventArgs e)
    {
        Ped player = Game.Player.Character;

        Ped[] ped = World.GetNearbyPeds(player, 100);

        Vehicle[] veh = World.GetNearbyVehicles(player, 100);

        if (e.KeyCode == Keys.Delete)
        {
            for (int i = 0; i < ped.Length; i++)
            {
                shoutPed(player, ped[i]);
            }
            for(int i = 0; i < veh.Length; i++){
                shoutVeh(player, veh[i]);
            }
            GTA.UI.ShowSubtitle("Fus Roh Dah!");
            DeletePEDArray(ped);
            DeleteVEHArray(veh);
        }
    }
    void shoutPed(Ped Player, Ped ped)
    {
        Function.Call(Hash.SET_PED_TO_RAGDOLL, ped, 4000, 4000, 0, 1, 1, 1);
        ped.Velocity.Equals(shout_strength);
        ped.ApplyForce(Player.ForwardVector * shout_strength);
    }
    void shoutVeh(Ped player, Vehicle veh)
    {
        float vehStrength = shout_strength - 10;
        veh.ApplyForce(player.ForwardVector * vehStrength);
    }
}